#ifndef XS_LENGTH_H
#define XS_LENGTH_H

#include "xmms-sid.h"
#include "xs_support.h"

#ifdef __cplusplus
extern "C" {
#endif

/* Types
 */
typedef struct _XSSLDBNode
{
    xs_md5hash_t    md5Hash;    /* 128-bit MD5 hash-digest */
    gint            nlengths;   /* Number of lengths */
    gint            *lengths;   /* Lengths in seconds */
    struct _XSSLDBNode *prev, *next;
} XSSLDBNode;


typedef struct
{
    XSSLDBNode     *nodes,
                    **pindex;
    size_t          n;
} XSSLDB;


/* Functions
 */
gint            xs_sldb_read(XSSLDB *, const gchar *);
gint            xs_sldb_index(XSSLDB *);
void            xs_sldb_free(XSSLDB *);
XSSLDBNode *    xs_sldb_get(XSSLDB *, const gchar *);

#ifdef __cplusplus
}
#endif
#endif /* XS_LENGTH_H */
