#ifndef XS_STIL_H
#define XS_STIL_H

#include "xmms-sid.h"

#ifdef __cplusplus
extern "C" {
#endif

/* Types
 */
typedef struct {
    gchar *name,
          *author,
          *title,
          *info;
} XSSTILSubNode;


typedef struct _XSSTILNode {
    gchar              *filename;
    gint               nsubTunes;
    XSSTILSubNode      **subTunes;
    struct _XSSTILNode *prev, *next;
} XSSTILNode;


typedef struct {
    XSSTILNode  *nodes,
                **pindex;
    size_t      n;
} XSSTILDB;


/* Functions
 */
gint            xs_stildb_read(XSSTILDB *, gchar *);
gint            xs_stildb_index(XSSTILDB *);
void            xs_stildb_free(XSSTILDB *);
XSSTILNode *    xs_stildb_get_node(XSSTILDB *, gchar *);

#ifdef __cplusplus
}
#endif
#endif /* XS_STIL_H */
